﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RemoteLibrary;

namespace RemoteServerLibrary
{
    [Serializable]
    public class Vare: IVare
    {
        private int varenr;
        private string betegnelse;
        private int antalPåLager;
        private float salgsEnhedsPris;
        private object varelås = new object();

        public Vare()       // default constructor  - skal bruges ved nyt registreret remote objekt
        { }

        public Vare(int varenr, string betegnelse, float salgsEnhedsPris)
        {
            this.varenr = varenr;
            this.betegnelse = betegnelse;
            this.salgsEnhedsPris = salgsEnhedsPris;
            Console.WriteLine("Vare:" + varenr + " oprettet");
        }

        #region IVare Members

        public int Varenr
        {
            get { return this.varenr; }
        }

        public string Betegnelse
        {
            get
            {
                return this.betegnelse;
            }
            set
            {
                this.betegnelse = value;
            }
        }

        public int AntalPåLager
        {
            get { return this.antalPåLager; }
        }

        public float SalgsEnhedsPris
        {
            get
            {
                lock (varelås)
                    return this.salgsEnhedsPris;
            }
            set
            {
                lock (varelås)
                    this.salgsEnhedsPris = value;
            }
        }

        public double Salgsværdi()
        {
            //lock (varelås)
            //    return this.salgsEnhedsPris * this.antalPåLager;
            return this.SalgsEnhedsPris * this.AntalPåLager;
        }

        public void RegistrerVarerSolgt(int antal)
        {
            this.antalPåLager -= antal;
        }

        public void RegistrerVarerIndkøbt(int antal)
        {
            this.antalPåLager += antal;
        }

        #endregion

        public override string ToString()
        {
            return "" + varenr + " ;" + betegnelse + " ;" + antalPåLager + " ;" + salgsEnhedsPris.ToString("F2");
        }
    }
}
