﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RemoteLibrary;

namespace RemoteServerLibrary
{
    public class Varekatalog: MarshalByRefObject, IVarekatalog
    {
        private List<IVare> vareListe = new List<IVare>();

        private object varekatalog_lås = new object();

        #region IVarekatalog Members

        public IVare OpretVare(int varenr, string betegnelse, int antalPåLager, float salgsEnhedsPris)
        {
            // precondition: der findes ikke andre vare med samme varenr
            Vare nyVare = new Vare(varenr, betegnelse, salgsEnhedsPris);
            lock (varekatalog_lås)
                vareListe.Add(nyVare);
            return nyVare;
        }

        public IVare[] GetAlleVarer()
        {
            lock (varekatalog_lås)
                return this.vareListe.ToArray();
        }

        public IVare FindVare(int varenr)
        {
            lock (varekatalog_lås)
            {
                foreach (IVare enVare in this.vareListe)
                {
                    if (enVare.Varenr == varenr)
                        return enVare;      // returner fundet
                }
            }
            return null;        // ikke fundet
        }

        #endregion
    }
}
